package appia.protocols.stf.client;

import appia.*;
import appia.events.*;
import appia.events.channel.*;
import appia.message.*;
import appia.protocols.udpsimple.RegisterSocketEvent;
import appia.protocols.udpsimple.InetWithPort;
import appia.protocols.remoteView.*;
import appia.protocols.group.*;
import appia.protocols.group.events.*;


import java.io.*;
import java.util.*;
import java.net.InetAddress;


/**
 * Classe que tem o codigo responsavel
 * pela parte especifica da aplicacao
 * cliente.
 * Dependendo da aplicacao que se quer fazer
 * pode ser necessario haver uma maneira
 * de fazer chamadas assincronas. 
 * (ver aplicacao de teste do Appia)
 */
public class ClientSession extends Session {


    public  Channel       channel=null;


    public ClientSession(ClientLayer l) {
	super(l);	
    }
    
    
    /**
     * Metodo chamado quando se recebe um evento.
     */
    public void handle(Event e) {


	if(e instanceof ChannelInit)
	    handleChannelInit((ChannelInit)e);	
	else if(e instanceof SendableEvent)
	    handleSendableEvent((SendableEvent)e);
	
    }

    /**
     * faz a inicializacao do canal.
     */
    private void handleChannelInit(ChannelInit e) {
	try {
	    e.go();
	}
	catch(AppiaEventException ex) {
	    System.err.println("Unexpected exception in Application "+
			       "session");
	}

	channel=e.getChannel();
	
	//regista o socket
	try {
	    RegisterSocketEvent rse=new
		RegisterSocketEvent(channel,new Direction(Direction.DOWN),
				    this,RegisterSocketEvent.RANDOMLY_AVAILABLE);
	    rse.go();
	}
	catch(appia.AppiaEventException ex) {
	    switch(ex.type) {
	    case appia.AppiaEventException.UNWANTEDEVENT :
		System.err.println("The QoS definition doesn't satisfy the "+
				   "application session needs. "+
				   "RegisterSocketEvent, received by "+
				   "UdpSimpleSession is not being acepted");
		break;
	    default :
		System.err.println("Unexpected exception in "+
				   "Application session");
		break;
	    }
	}
	
	System.out.println("Open channel with name "+e.getChannel().getChannelID());


    }

    //trata o sendable event, por exemplo as respostas dos clientes.
    private void handleSendableEvent(SendableEvent e){
    }



    /**
     * Retorna a Layer desta Session.
     */
    public Layer getLayer() {
	return layer;
    }
}
