package appia.protocols.stf.coordination;

import appia.*;
import appia.events.*;

/**
 * Classe que define os eventos
 * que esta camada aceita, precisa
 * e fornece.
 * Pode ser necessario adicionar
 * novos eventos.
 */
public class CoordinationLayer extends Layer {

  public CoordinationLayer() {
    try {
      Class rse=Class.forName("appia.protocols.udpsimple.RegisterSocketEvent");
      Class init=Class.forName("appia.protocols.group.events.GroupInit");
      Class view=Class.forName("appia.protocols.group.intra.View");
      Class cinit=Class.forName("appia.events.channel.ChannelInit");
      Class cclose=Class.forName("appia.events.channel.ChannelClose");
      Class blockok=Class.forName("appia.protocols.group.sync.BlockOk");
      Class send=Class.forName("appia.events.SendableEvent");
      Class gsend=Class.forName("appia.protocols.group.events.GroupSendableEvent");
	    

      evProvide=new Class[2];
      evProvide[0]=send;
      evProvide[1]=gsend;

      evRequire= new Class[0];

      evAccept=new Class[6];
      evAccept[0]=gsend;
      evAccept[1]=cinit;
      evAccept[2]=cclose;
      evAccept[3]=view;
      evAccept[4]=blockok;
      evAccept[5]=send;



    } catch (ClassNotFoundException ex) {
      ex.printStackTrace();
      throw new AppiaError("CoordLayer: !!!!!!");
    }
  }

  public Session createSession() {
    return new CoordinationSession(this);
  }
}
