package appia.protocols.stf.server;

import appia.*;
import appia.events.*;

/**
 * Classe que define os eventos que a camada
 * aceita, precisa e fornece.
 * Pode ser necesario acrescentar novos eventos
 * aqui.
 */
public class ServerLayer extends Layer {

  public ServerLayer() {
    try {
      Class rse=Class.forName("appia.protocols.udpsimple.RegisterSocketEvent");
      Class init=Class.forName("appia.protocols.group.events.GroupInit");
      Class view=Class.forName("appia.protocols.group.intra.View");
      Class cinit=Class.forName("appia.events.channel.ChannelInit");
      Class cclose=Class.forName("appia.events.channel.ChannelClose");
      Class blockok=Class.forName("appia.protocols.group.sync.BlockOk");
      Class gsend=Class.forName("appia.protocols.group.events.GroupSendableEvent");

      evProvide=new Class[2];
      evProvide[0]=init;
      evProvide[1]=rse;


      evRequire= new Class[0];

      evAccept=new Class[5];
      evAccept[0]=gsend;
      evAccept[1]=cinit;
      evAccept[2]=cclose;
      evAccept[3]=view;
      evAccept[4]=blockok;


    } catch (ClassNotFoundException ex) {
      ex.printStackTrace();
      throw new AppiaError("ServerLayer: !!!!!!");
    }
  }

  public Session createSession() {
    return new ServerSession(this);
  }
}
